/*
 * YACA : Yet Another Contact Application 
 * by PhilFlash - http://philflash.inway.fr
 *
 */

import mx.controls.Button;
import mx.controls.TextInput;
import mx.controls.DataGrid;

import Validation;

class EditContactForm extends mx.screens.Form {

	public var ok_editf:Button = null;
	public var cancel_editf:Button = null;	
	
	public var first_editf:TextInput = null;	
	
	public var last_editf:TextInput = null;	
	public var lastLabel_editf:MovieClip = null;
	
	public var email_editf:TextInput = null;	
	public var emailLabel_editf:MovieClip = null;	
	
	public var work_editf:TextInput = null;	
	public var workLabel_editf:MovieClip = null;	
	
	public var home_editf:TextInput = null;	
	public var homeLabel_editf:MovieClip = null;	
	
	public var title_editf:MovieClip = null;
	
	private var errorTextFormat;
	private var normalTextFormat;
	
	
	private var isNew:Boolean = false;
	
	// Constructor
	public function EditContactForm() {}
	

	public function init():Void {
		super.init();
		addEventListener("load", onLoad);
		addEventListener("reveal", onReveal);
		addEventListener("allTransitionsOutDone", this);	
		
		errorTextFormat	= new TextFormat();
		errorTextFormat.color = 0xFF0000;
		errorTextFormat.font = "_sans";
		errorTextFormat.size = 12;	 
		errorTextFormat.bold = true;	
		
		normalTextFormat	= new TextFormat();
		normalTextFormat.color = 0x000000;
		normalTextFormat.font = "_sans";
		normalTextFormat.size = 12;	 
		normalTextFormat.bold = true;
		
	}
	
	public function onLoad():Void {
		setVisible(false);

		ok_editf.addEventListener("click", function(evt:Object) { evt.target._parent.okAction(evt); } );
		cancel_editf.addEventListener("click", function(evt:Object) { evt.target._parent.cancelAction(evt); } );
		
	}
	
	// ----- Reveal and Transition -----
	public function onReveal():Void {	
		var transition:Object = null;
		
		// Update Title
		title_editf.text = (isNew ? MyLocale.getString("IDS_NEW_TITLE") : MyLocale.getString("IDS_EDIT_TITLE"));
		
		lastLabel_editf.setTextFormat(normalTextFormat);		
		emailLabel_editf.setTextFormat(normalTextFormat);		
		workLabel_editf.setTextFormat(normalTextFormat);		
		homeLabel_editf.setTextFormat(normalTextFormat);
		
		// ----
		
		transition = new Object();
		
		if (isNew) {
			transition = new Object();
			transition.type = mx.transitions.Iris;
			transition.direction = 0;
			transition.duration = 1;
			transition.easing = mx.transitions.easing.None.easeNone;
			transition.startPoint = 5;
			transition.param2 = "SQUARE";
			
			mx.transitions.TransitionManager.start( this, transition );	
			
		} else {
				
			transition.type = mx.transitions.Fly;
			transition.direction = 0;
			transition.duration = 1;
			transition.easing = mx.transitions.easing.None.easeNone;
			transition.startPoint = 8;
			transition.param2 = "";

			mx.transitions.TransitionManager.start( this, transition );	
		}
		
	}
	
	public function allTransitionsOutDone():Void {
		setVisible(false);
 		(rootForm).listcontact.setVisible(true);
	}
	
	// ----- Button Action -----
	public function okAction(eventObj:Object):Void {
		var target:Button = eventObj.target;
		var currentIndex:Number = (rootForm).contact_ds.selectedIndex;
		var datagrid:DataGrid = (rootForm).listcontact.contact_dg;

		if (check()) {
			// Update Model "avec prudence" pour updateResolver
			// en deux phases 
			// Si on le fais en une phase, le premier editField remets  jour la vue
			// et on perd les nouvelle valeurs
			var currentItem = (rootForm).contact_ds.currentItem;
			var model:Array = ["first", "last", "email", "work", "home"];
			var view:Array = ["first_editf", "last_editf", "email_editf", "work_editf", "home_editf"];
			// -- init new Values
			var newValues:Array = new Array();
			var len = model.length;
			for (var i:Number = 0; i < len; i++) {
				newValues.push(undefined);
			}
			// -- check new Values
			for (var i:Number = 0; i < len; i++) {
				var oldValue:String = currentItem[model[i]];
				var newValue:String = trimSpacer(this[view[i]].text);
				if (newValue != oldValue) {
					newValues[i] = newValue;
				}
			}
			// -- update Model
			for (var i:Number = 0; i < len; i++) {
				var newValue = newValues[i];
				if (newValue != undefined) {
					datagrid.editField(currentIndex, model[i], newValue);					
				}
			}				
			closeAction();
		}
	}


	public function cancelAction(eventObj:Object):Void {
		// Remove added Item if new
		if (isNew) {
			(rootForm).contact_ds.removeItem();
		}
		closeAction();
	}
	
	public function closeAction():Void {
		var transition:Object = null;	
		
		if (isNew) {
			transition = new Object();
			transition.type = mx.transitions.Iris;
			transition.direction = 1;
			transition.duration = 1;
			transition.easing = mx.transitions.easing.None.easeNone;
			transition.startPoint = 5;
			transition.param2 = "SQUARE";

			mx.transitions.TransitionManager.start( this, transition );	
		} else {
			transition = new Object();
			transition.type = mx.transitions.Fly;
			transition.direction = 1;
			transition.duration = 1;
			transition.easing = mx.transitions.easing.None.easeNone;
			transition.startPoint = 8;
			transition.param2 = "";

			mx.transitions.TransitionManager.start( this, transition );	
		}

	}
	
	// ----- Check -----
	public function check():Boolean {	
	
		var label:String;
		var check:Boolean = true;
		// Check Last
		label = trimSpacer(last_editf.text);
		if (label.length == 0) {
			lastLabel_editf.setTextFormat(errorTextFormat);
			check = false;
		} else {
			lastLabel_editf.setTextFormat(normalTextFormat);		
		}
		// Check Email
		label = trimSpacer(email_editf.text);
		if (label.length != 0 && !Validation.isEmail(label)) {
			emailLabel_editf.setTextFormat(errorTextFormat);
			check = false;
		} else {
			emailLabel_editf.setTextFormat(normalTextFormat);		
		}
		// Check Work Phone 
		label = trimSpacer(work_editf.text);
		if (label.length != 0 && !Validation.isPhoneNumber(label)) {
			workLabel_editf.setTextFormat(errorTextFormat);
			check = false;
		} else {
			workLabel_editf.setTextFormat(normalTextFormat);		
		}
		// Check Home Phone 
		label = trimSpacer(home_editf.text);
		if (label.length != 0 && !Validation.isPhoneNumber(label)) {
			homeLabel_editf.setTextFormat(errorTextFormat);
			check = false;
		} else {
			homeLabel_editf.setTextFormat(normalTextFormat);		
		}
		return check;
	}
	
	// -----  -----	
	public function refreshLangForComponents():Void {
		ok_editf.label = MyLocale.getString("IDS_LABEL_OK");
		cancel_editf.label = MyLocale.getString("IDS_LABEL_CANCEL");
	}

	// -----  -----	
	public function trimSpacer(str:String):String {
		if (str == undefined || str == "") {
			return "";
		}
		for (var i:Number = 0; i < str.length && (str.charAt(i) == ' ' || str.charAt(i) == '\n' || str.charAt(i) == '\t' || str.charAt(i) == '\r'); i++);
		for (var j:Number = str.length - 1; j >= i && (str.charAt(j) == ' ' || str.charAt(j) == '\n' || str.charAt(j) == '\t' || str.charAt(j) == '\r'); j--);
		return str.substring(i, ++j);
	}
}
