class Validation {

	// Constructor
	public function Validation() {}
	
	
	static function hasValidChars(str:String, chars:String):Boolean {	
		var str = str.toLowerCase();
		if(str.length == 0) return false;

		var chars = chars.toLowerCase();
		var cArr = str.split("");
		var len = cArr.length;
		for(var i = 0; i < len; i++){
			var valid = (chars.indexOf(cArr[i]) != -1)
			if(!valid) return false;
		}

		return true;
	
	}

	static function isDigit(n):Boolean {	
		return !isNaN(Number(n));
	}
	
	static function isLetter(n):Boolean {	
		if(n=="" || n==null) return false;
		return "abcdefghijklmnopqrstuvwxyz".indexOf(n.toLowerCase())!=-1;
	}

	static function isAlphaNumeric(str:String):Boolean {	
		return Validation.hasValidChars(str,"0123456789abcdefghijklmnopqrstuvwxyz")
	}

	static function isLetterOrDigit(n):Boolean {	
		var ret = (Validation.isLetter(n) || Validation.isDigit(n));
		return ret;
	}

	static function isURL(str:String):Boolean { 
		var str = str.toLowerCase();

		if(!Validation.hasValidChars
		   (
				str,
				"0123456789abcdefghijklmnopqrstuvwxyz-.:/"
			)
		){
			return false;
		}

		var start = str.indexOf("http://");

		if(start!=0) return false;

		var char = str.substr(7,1);
		if(!Validation.isLetterOrDigit(char)){

			return false;

		}

		if(str.length < 8) return false;

		return true;
	}

	static function isEmail(str:String):Boolean { 
		var str = str.toLowerCase();

		if(!Validation.hasValidChars
			(
				str,
				"0123456789abcdefghijklmnopqrstuvwxyz-.@"
			)
		){
			return false;
		}

		var parts = str.split("@");

		if(parts.length!=2) return false;

		var start = parts[1].indexOf(".");
		if(start<0) return false;

		var domain = parts[1].split(".");
		var ext = domain.pop();

		if(ext.length<2) return false;

		if(domain[0].length < 2) return false;

		return true;
	}

	static function isPhoneNumber(str:String):Boolean {
		if(!Validation.hasValidChars(str,"+() .0123456789")) return false;

		var countDigit = 0;
		var char;
		for (var i = 0; i < str.length; i++) {
			char = str.substr(i,1);
			if ("0123456789".indexOf(char)!=-1) {
				countDigit++;
			}
		}
		if (countDigit < 10) {
			return false;
		}
		return true;
	}

}
